//  DHHalLib_Test_App.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include <iostream>

using namespace std;


int wmain(int argc, wchar_t *argv[])
{
	BacklightTest backlightTest;
	ControlTest controlTest;
	GPIOTest gpioTest;
	I2CTest i2cTest;
	MEMTest memTest;
	TouchTest touchTest;
	VersionTest versionTest;
	SPITest spiTest;
	UARTTest uartTest;
	CANTest canTest;

	int TEST_SELECT;

		// Wait Loop for 0 to Exit
		do
		{
			cout << "---------------------------------" << endl;
			cout << "DHHalLib Test Selection!" << endl;
			cout << "---------------------------------" << endl;
			cout << "1: Backlight Function Test" << endl;
			cout << "2: Control Function Test" << endl;
			cout << "3: Gpio Function Test" << endl;
			cout << "4: I2c Function Test" << endl;
			cout << "5: Physical Memory Function Test" << endl;
			cout << "6: Touch Function Test" << endl;
			cout << "7: Version Function Test" << endl;
			cout << "8: SPI Function Test" << endl;
			cout << "9: UART Function Test" << endl;
			cout << "10: CAN Function Test" << endl;
			cout << "0: Exit App" << endl;
			cout << "---------------------------------" << endl;
			cout << "Enter Test Number: (0 ... 10): ";
			cin >> TEST_SELECT;

			switch(TEST_SELECT)
			{
			case 1:
				{
					backlightTest.StartBacklightTest();
				}
				break;
			case 2:
				{
					controlTest.StartControlTest();
				}
				break;
			case 3:
				{
					gpioTest.StartGpioTest();
				}
				break;
			case 4:
				{
					i2cTest.StartI2cTest();
				}
				break;
			case 5:
				{
					memTest.StartMemTest();
				}
				break;
			case 6:
				{
					touchTest.StartTouchTest();
				}
				break;
			case 7:
				{
					versionTest.StartVersionTest();
				}
				break;
			case 8:
				{
					spiTest.StartSpiTest();
				}
				break;
			case 9:
				{
					uartTest.StartUartTest();
				}
				break;
			case 10:
				{
					canTest.StartCanTest();
				}
				break;
			case 0:
				{
					return true;
				}
			default:
				{
					cout << "Not valid Test Function!!!" << endl;
				}
				break;
			}
		}while(1); //GPIO_PIN_TEST != 0);

	return 0;
}
