/*
//	Description: Demo I2C Functions
//	File:		I2CTest.cpp
//	Created:	Christian Apfel
//	Date:		23.12.2015
//
*/

#include "stdafx.h"
#include "I2CTest.h"

using namespace std;

I2CTest::I2CTest()
{

}

I2CTest::~I2CTest()
{

}

// ****** Demo App Menu Functions ******

void I2CTest::StartI2cTest()
{
	int I2C_TEST;
	int I2C_DEV;
	int I2C_DEV_FREQ;
	int I2C_DEV_ADDR;
	int I2C_REG_ADDR;
	unsigned char I2C_DATA;
	unsigned char I2C_DATA_ARRAY[32];
	unsigned char I2C_DATA_LEN;
	char *cStatus = new char[20];

	// Wait Loop for 0 to Exit
	do
	{
		cout << "---------------------------------" << endl;
		cout << "Select I2C Test!" << endl;
		cout << "---------------------------------" << endl;
		cout << "1: Write Test" << endl;
		cout << "2: Read Test" << endl;
		cout << "3: Write Flash Test" << endl;
		cout << "4: Read Flash Test" << endl;
		cout << "0: Main Menu" << endl;
		cout << "---------------------------------" << endl;
		cout << "Enter Test Number: ";
		cin >> I2C_TEST;

		switch(I2C_TEST)
		{
		case 1:
			{
				cout << endl;
				cout << "I2C Write Test" << endl;
				cout << "------------------------------------" << endl;
				cout << "Enter I2C Device Number (0,1): ";
				cin >> I2C_DEV;
				cout << "Enter I2C Device Bitrate (0=100|1=400|2=800|3=1600|4=2400|5=3200 kBits): ";
				cin >> I2C_DEV_FREQ;
				cout << "Enter I2C Device Address (e.g. 50 = 0x50): ";
				cin >> std::hex >> I2C_DEV_ADDR;
				cout << "Enter I2C Register Address (e.g. 0 = 0x00): ";
				cin >> std::hex >> I2C_REG_ADDR;
				cout << "Enter I2C Data (e.g. 1 = 0x01): ";
				cin >> std::hex >> I2C_DATA;

				if(I2CWriteTest(DHCOM_I2CEnum(I2C_DEV), DHCOM_I2CFREQMode(I2C_DEV_FREQ), I2C_DEV_ADDR, I2C_REG_ADDR, &I2C_DATA) == true)
				{
					cStatus = "Success";
				}
				else
				{
					cStatus = "Failed";
				}

				cout << "I2C Write Test from " << std::hex << I2C_DEV_ADDR << " is " << cStatus << "!!!" << endl;
				cout << "------------------------------------" << endl;
			}
			break;
		case 2:
			{
				cout << endl;
				cout << "I2C Read Test" << endl;
				cout << "------------------------------------" << endl;
				cout << "Enter I2C Device Number (0,1): ";
				cin >> I2C_DEV;
				cout << "Enter I2C Device Bitrate (0=100|1=400|2=800|3=1600|4=2400|5=3200 kBits): ";
				cin >> I2C_DEV_FREQ;
				cout << "Enter I2C Device Address (e.g. 50 = 0x50): ";
				cin >> std::hex >> I2C_DEV_ADDR;
				cout << "Enter I2C Register Address (e.g. 0 = 0x00): ";
				cin >> std::hex >> I2C_REG_ADDR;

				I2C_DATA = 0;

				if(I2CReadTest(DHCOM_I2CEnum(I2C_DEV), DHCOM_I2CFREQMode(I2C_DEV_FREQ), I2C_DEV_ADDR, I2C_REG_ADDR, &I2C_DATA) == true)
				{
					cStatus = "Success";
				}
				else
				{
					cStatus = "Failed";
				}

				cout << "I2C Read Test from " << std::hex << I2C_DEV_ADDR << " with Data " << I2C_DATA << " is " << cStatus << "!!!" << endl;
				cout << "------------------------------------" << endl;
			}
			break;
		case 3:
			{
				cout << endl;
				cout << "I2C Write Flash Test" << endl;
				cout << "------------------------------------" << endl;
				cout << "Enter I2C Device Number (0,1): ";
				cin >> I2C_DEV;
				cout << "Enter I2C Device Bitrate (0=100|1=400|2=800|3=1600|4=2400|5=3200 kBits): ";
				cin >> I2C_DEV_FREQ;
				cout << "Enter I2C Device Address (e.g. 50 = 0x50): ";
				cin >> std::hex >> I2C_DEV_ADDR;
				cout << "Enter I2C Register Address (e.g. 0 = 0x00): ";
				cin >> std::hex >> I2C_REG_ADDR;
				cout << "Enter I2C Data (e.g. 1 = 0x01): ";
				cin >> &I2C_DATA_ARRAY[0];
				cout << "Enter I2C Data Len (e.g. 2 = 0x02): ";
				scanf("%d", &I2C_DATA_LEN);

				//I2C_DATA_ARRAY[0] = I2C_DATA;

				if(I2CWriteMultible(DHCOM_I2CEnum(I2C_DEV), DHCOM_I2CFREQMode(I2C_DEV_FREQ), I2C_DEV_ADDR, I2C_REG_ADDR, I2C_DATA_ARRAY, I2C_DATA_LEN) == true)
				{
					cStatus = "Success";
				}
				else
				{
					cStatus = "Failed";
				}

				cout << "I2C Write Test from " << I2C_DEV_ADDR << " with Register Address:" << I2C_REG_ADDR << " is " << cStatus << "!!!" << endl;
				cout << "------------------------------------" << endl;
			}
			break;
		case 4:
			{
				cout << endl;
				cout << "I2C Read Flash Test" << endl;
				cout << "------------------------------------" << endl;
				cout << "Enter I2C Device Number (0,1): ";
				cin >> I2C_DEV;
				cout << "Enter I2C Device Bitrate (0=100|1=400|2=800|3=1600|4=2400|5=3200 kBits): ";
				cin >> I2C_DEV_FREQ;
				cout << "Enter I2C Device Address (e.g. 50 = 0x50): ";
				cin >> std::hex >> I2C_DEV_ADDR;
				cout << "Enter I2C Register Address (e.g. 0 = 0x00): ";
				cin >> std::hex >> I2C_REG_ADDR;
				cout << "Enter I2C Data Len (e.g. 2 = 0x02): ";
				scanf("%d", &I2C_DATA_LEN);

				if(I2CReadMultible(DHCOM_I2CEnum(I2C_DEV), DHCOM_I2CFREQMode(I2C_DEV_FREQ), I2C_DEV_ADDR, I2C_REG_ADDR, I2C_DATA_ARRAY, I2C_DATA_LEN) == true)
				{
					cStatus = "Success";
				}
				else
				{
					cStatus = "Failed";
				}

				cout << "I2C Read Test from " << I2C_DEV_ADDR << " with Register Address:" << I2C_REG_ADDR << " is " << cStatus << "!!!" << endl;
				cout << "------------------------------------" << endl;

				cout << "Data String: " << I2C_DATA_ARRAY << endl;
			}
			break;
		case 0:
			{
				return;
			}
			break;
		default:
			{

			}
			break;
		}
	}while(1);
}

// ****** I2C Functions ******

bool I2CTest::I2CWriteTest(DHCOM_I2CEnum eI2C, DHCOM_I2CFREQMode eI2CFreq, unsigned char ucDevAddr, unsigned char ucRegAddr, unsigned char *ucData)
{
	if(I2CWrite(eI2C, eI2CFreq, ucDevAddr, ucRegAddr, *ucData) == true)
	{
		return true;
	}

	return false;
}

bool I2CTest::I2CReadTest(DHCOM_I2CEnum eI2C, DHCOM_I2CFREQMode eI2CFreq, unsigned char ucDevAddr, unsigned char ucRegAddr, unsigned char *ucData)
{
	if(I2CRead(eI2C, eI2CFreq, ucDevAddr, ucRegAddr, ucData) == true)
	{
		return true;
	}

	return false;
}

bool I2CTest::I2CWriteMultible(DHCOM_I2CEnum eI2C, DHCOM_I2CFREQMode eI2CFreq, unsigned char ucDevAddr, unsigned char ucRegAddr, unsigned char *ucData, unsigned char ucLen)
{
	I2CWriteMultipleBytes(eI2C, eI2CFreq, ucDevAddr, ucRegAddr, ucLen, ucData);

	return true;
}

bool I2CTest::I2CReadMultible(DHCOM_I2CEnum eI2C, DHCOM_I2CFREQMode eI2CFreq, unsigned char ucDevAddr, unsigned char ucRegAddr, unsigned char *ucData, unsigned char ucLen)
{
	if(I2CReadMultipleBytes(eI2C, eI2CFreq, ucDevAddr, ucRegAddr, ucLen, ucData) == true)
	{
		return true;
	}

	return false;
}